<Cabbage>
form caption("Internal Presets") size(660, 620), guiMode("queue"), colour(240, 240, 240), pluginId("inpr")

hslider bounds(20, 180, 120, 20), channel("presets"), range(1, 6, 1, 1, 1), filmstrip("hGridSlider6.png", 6);, popupText(0)

</Cabbage>

<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 --midi-key-cps=4 --midi-velocity-amp=5
</CsOptions>
<CsInstruments>

///////////////////////////////////////////////////////////////////////////// GLOBAL
 
ksmps       =   32
nchnls      =   2
0dbfs       =   1

massign     0, "guiCtl"
;---------------------------------------------------------------------------- GRID

giG1Size    =   20
giG1Cols    =   6
giG1Rows    =   7
giG1Left    =   20
giG1Top     =   20
giG1Id      =   1

///////////////////////////////////////////////////////////////////////////// UDOS

opcode GridDraw, 0, iiiiii
    iSize, iCols, iRows, iLeft, iTop, iId    xin
    
    iCount  init    0

    while iCount < iCols do
        SCode   sprintf "bounds(%d, %d, %d, %d) channel(\"g%dc%d\") range(0, %d, 0, 1, 1), filmstrip(\"vGridSlider%d.png\", %d, valueTextBox(\"0\"), popup(\"0\")", iCount*iSize+iLeft, iTop, iSize, iSize*iRows, iId, iCount+1, iRows-1, iRows, iRows
        cabbageCreate "vslider", SCode
        iCount+=1
    od
    
    SCode = sprintf("bounds(%d, %d, %d, %d), channel(\"overlay%d\"), colour(0, 0, 0, 0)", iLeft, iTop, iSize*iCols, iSize*iRows, iId) 
    cabbageCreate "image", SCode
endop

;---------------------------------------------------------------------------- GRID CONTROL

opcode GridCtl, 0, iiii
    iSize, iCols, iRows, iId    xin
    

    kMouseDown  chnget  "MOUSE_DOWN_LEFT"
    kMouseX     chnget  "MOUSE_X"
    kMouseY     chnget  "MOUSE_Y"
    
    SOverlay    sprintf "overlay%d", iId
   
    iOverlay[]  cabbageGet SOverlay, "bounds" 
    iLeft       = iOverlay[0]
    iTop        = iOverlay[1]
    iWidth      = iOverlay[2]
    iHeight     = iOverlay[3] 
   
    if kMouseDown == 1 then
        if (kMouseX > iLeft && kMouseX < iLeft+iWidth && kMouseY > iTop && kMouseY < iTop + iHeight) then
            kColumn = int(((kMouseX - iLeft) / iSize) + 1)
            kVal    = int(((kMouseY - iTop) * -iRows / iHeight) + iRows)

            SChannel = sprintfk("g%dc%d", iId, kColumn)
            cabbageSetValue SChannel, kVal
        endif
    endif
endop

///////////////////////////////////////////////////////////////////////////// INIT

instr guiDraw
    
    GridDraw    giG1Size, giG1Cols, giG1Rows, giG1Left, giG1Top, giG1Id

endin

instr guiCtl
 
    GridCtl     giG1Size, giG1Cols, giG1Rows, giG1Id

    ivel    veloc 0, 1
    inote   notnum
    kPreset, kTrig cabbageGetValue "presets"
        
    if changed:k(ivel) == 1 then
        if inote == 60 then
            cabbageSetValue "presets", 1
        elseif inote == 62 then
            cabbageSetValue "presets", 2
        elseif inote == 64 then
            cabbageSetValue "presets", 3
        elseif inote == 65 then
            cabbageSetValue "presets", 4
        elseif inote == 67 then
            cabbageSetValue "presets", 5
        elseif inote == 69 then
            cabbageSetValue "presets", 6
        endif
    endif
    
    if kTrig == 1 then
        SIgnore[] init 1
        SIgnore[0] = "presets"
        SFile sprintfk "Preset%d.pre", kPreset
        kOk = cabbageChannelStateRecall:k(SFile, SIgnore)
      
        cabbageSetValue "g1c1", cabbageGetValue:k("g1c1")
        cabbageSetValue "g1c2", cabbageGetValue:k("g1c2")
        cabbageSetValue "g1c3", cabbageGetValue:k("g1c3")
        cabbageSetValue "g1c4", cabbageGetValue:k("g1c4")
        cabbageSetValue "g1c5", cabbageGetValue:k("g1c5")
        cabbageSetValue "g1c6", cabbageGetValue:k("g1c6")
   endif

   if changed:k(chnget:k("g1c1")) == 1 || changed:k(chnget:k("g1c2")) == 1 || changed:k(chnget:k("g1c3")) == 1 || changed:k(chnget:k("g1c4")) == 1 || changed:k(chnget:k("g1c5")) == 1 || changed:k(chnget:k("g1c6")) == 1 then
      SPath = chnget:S("CSD_PATH")
      SFile sprintfk "Preset%d.pre", kPreset
      
      kOk = cabbageChannelStateSave:k(SFile)
   endif
endin

</CsInstruments>
<CsScore>
i "guiDraw" 0 0.5
i "guiCtl"  0 z
</CsScore>
</CsoundSynthesizer>